// ##########################################################################
// ####                                                                  ####
// ####                         Prfungsamt-Client                       ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Sichtendefinitionen                                              ####
// ####                                                                  ####
// #### Version 1.00  --  12. Juli 2000                                  ####
// ####                                                                  ####
// #### Copyright (C) 2000  Thomas Dreibholz                             ####
// ####                     Universitt Bonn                             ####
// ####                     EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################


#include "system.h"
#include "paviews.h"


// **************************************************************************
// ACHTUNG:
//    Alle Attributnamen der folgenden Auflistungen in Kleinschreibung!!!
// **************************************************************************


extern const ViewTable Pruefer_ViewTable;
extern const ViewTable Studenten_ViewTable;


// ##########################################################################
// #### Adretypen                                                       ####
// ##########################################################################

const DescriptionEntry Adresstypen_DescriptionEntries[] =
{
   {"adr_typ",      "Typ",          "Adre-Typ"},
   {"adr_txt",      "Beschreibung", "Beschreibung"},
   {"typ_adressen", "Adretyp",     "Tupel der Adretypen-Tabelle"}
};

const ViewEntry Adresstypen_ViewEntries[] =
{
   {
      "Alle Adretypen", "typ_adressen", "adr_typ",
      0, NULL,
      0, NULL,
      sizeof(Adresstypen_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Adresstypen_DescriptionEntries
   }
};


const ViewTable Adresstypen_ViewTable =
{
   {"adr_typ", NULL, NULL, NULL, NULL},
   "typ_adressen",
   "Pixmaps/Adretypen.xpm",
   sizeof(Adresstypen_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Adresstypen_ViewEntries
};




// ##########################################################################
// #### Adressen                                                         ####
// ##########################################################################

const DescriptionEntry Adressen_DescriptionEntries[] =
{
   {"id",              "Nummer",      "Kennung"},
   {"zaehler",         "Zhler",      "Zhler"},
   {"strasse",         "Strae",      "Strae und Hausnummer"},
   {"ort",             "Ort",         "Ort"},
   {"plz",             "PLZ",         "Postleitzahl"},
   {"land",            "Land",        "Land"},
   {"telefon1",        "Telefon 1",   "1. Telefon-Nummer"},
   {"telefon2",        "Telefon 2",   "2. Telefon-Nummer"},
   {"fax",             "Telefax",     "Telefax-Nummer"},
   {"email",           "EMail",       "EMail-Adresse"},
   {"adr_typ",         "Typ",         "Adre-Typ"},
   {"sonstiges",       "Sonstiges",   "Sonstiges"},
   {"raum",            "Raum",        "Raum"},
   {"adr_typ",         "Typ",         "Adre-Typ"},
   {"pers_adressen",   "Adresse",     "Tupel der Adressen-Tabelle"}
};

const SelectEntry Adressen_SelectEntries[] =
{
   {"adr_typ", "adr_typ", "adr_txt", true, &Adresstypen_ViewTable},
};


const ViewEntry Adressen_ViewEntries[] =
{
   {
      "Alle Adressen", "pers_adressen", "ort",
      0, NULL,
      sizeof(Adressen_SelectEntries) / sizeof(SelectEntry),
      (const SelectEntry*)&Adressen_SelectEntries,
      sizeof(Adressen_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Adressen_DescriptionEntries
   }
};


const ViewTable Adressen_ViewTable =
{
   {"id", "zaehler", NULL, NULL, NULL},
   "pers_adressen",
   "Pixmaps/Adressen.xpm",
   sizeof(Adressen_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Adressen_ViewEntries
};



// ##########################################################################
// #### Studientypen                                                       ####
// ##########################################################################

const DescriptionEntry Studientypen_DescriptionEntries[] =
{
   {"studium_typ", "Studientyp",   "Studientyp"},
   {"studium_txt", "Beschreibung", "Beschreibung"},
   {"typ_studium", "Studientyp",   "Tupel der Studientypen-Tabelle"}
};

const ViewEntry Studientypen_ViewEntries[] =
{
   {
      "Alle Studiumstypen", "typ_studium", "studium_typ",
      0, NULL,
      0, NULL,
      sizeof(Studientypen_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Studientypen_DescriptionEntries
   }
};


const ViewTable Studientypen_ViewTable =
{
   {"studium_typ", NULL, NULL, NULL, NULL},
   "typ_studium",
   "Pixmaps/Studientypen.xpm",
   sizeof(Studientypen_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Studientypen_ViewEntries
};



// ##########################################################################
// #### Semestertext                                                       ####
// ##########################################################################

const DescriptionEntry Semestertext_DescriptionEntries[] =
{
   {"semester_txt", "Beschreibung", "Beschreibung"}
};

const ViewEntry Semestertext_ViewEntries[] =
{
   {
      "Alle Semestertexte", "typ_semestertxt", "semester_txt",
      0, NULL,
      0, NULL,
      sizeof(Semestertext_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Semestertext_DescriptionEntries
   }
};


const ViewTable Semestertext_ViewTable =
{
   {"semester_txt", NULL, NULL, NULL, NULL},
   "typ_semestertxt",
   "Pixmaps/Semestertext.xpm",
   sizeof(Semestertext_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Semestertext_ViewEntries
};



// ##########################################################################
// #### Studium                                                         ####
// ##########################################################################

const DescriptionEntry Studium_DescriptionEntries[] =
{
   {"stud_id",      "MatrNr",     "Matrikelnummer"},
   {"semester",     "Semester",   "Semester"},
   {"studien_typ",  "Studientyp", "Studientyp"},
   {"uni_studium",  "Studium",    "Tupel der Studium-Tabelle"}
};

const SelectEntry Studium_SelectEntries[] =
{
   {"studien_typ", "studium_typ",  "studium_txt",            true,  &Studientypen_ViewTable},
   {"semester",    "semester_txt", "semester_txt",           true,  &Semestertext_ViewTable},
   {"stud_id",     "stud_id",      "vorname, name, stud_id", false, &Studenten_ViewTable}
};


const ViewEntry Studium_ViewEntries[] =
{
   {
      "Gesamt", "uni_studium", "semester",
      0, NULL,
      sizeof(Studium_SelectEntries) / sizeof(SelectEntry),
      (const SelectEntry*)&Studium_SelectEntries,
      sizeof(Studium_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Studium_DescriptionEntries
   }
};


const ViewTable Studium_ViewTable =
{
   {"stud_id", "semester", NULL, NULL, NULL},
   "uni_studium",
   "Pixmaps/Studium.xpm",
   sizeof(Studium_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Studium_ViewEntries
};



// ##########################################################################
// #### Qualifikattypen                                                      ####
// ##########################################################################

const DescriptionEntry Qualifikattypen_DescriptionEntries[] =
{
   {"qal_typ", "Art",          "Qualifikations-Art"},
   {"qal_grp", "Gruppe",       "Gruppe"},
   {"qal_txt", "Beschreibung", "Beschreibung"},
   {"typ_qualifikate", "Qualifikation", "Tupel der Qualifikattypen-Tabelle"}
};

const ViewEntry Qualifikattypen_ViewEntries[] =
{
   {
      "Alle Qualifikattypen","typ_qualifikate","qal_grp, qal_txt",
      0, NULL,
      0, NULL,
      sizeof(Qualifikattypen_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Qualifikattypen_DescriptionEntries
   }
};

const ViewTable Qualifikattypen_ViewTable =
{
   {"qal_typ", NULL, NULL, NULL, NULL},
   "typ_qualifikate",
   "Pixmaps/Qualifikattypen.xpm",
   sizeof(Qualifikattypen_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Qualifikattypen_ViewEntries
};




// ##########################################################################
// #### Leistungsnachweise                                               ####
// ##########################################################################

const DescriptionEntry Leistungsnachweise_DescriptionEntries[] =
{
   {"stud_id",   "MatrNr",        "Matrikelnummer"},
   {"pers_id",   "PersNr",        "Personalnummer"},
   {"datum",     "Datum",         "Datum"},
   {"titel",     "Titel",         "Titel"},
   {"bemerkung", "Bemerkung",     "Bemerkung"},
   {"qal_typ",   "Qualifikation", "Qualifikations-Art"},
   {"uni_qualifikate", "Leistungsnachweis", "Tupel der Leistungsnachweise-Tabelle"}
};

const SelectEntry Leistungsnachweise_SelectEntries[] =
{
   {"qal_typ", "qal_typ", "qal_txt",                false, &Qualifikattypen_ViewTable},
   {"pers_id", "pers_id", "vorname, name, pers_id", false, &Pruefer_ViewTable},
   {"stud_id", "stud_id", "vorname, name, stud_id", false, &Studenten_ViewTable}
};


const ViewEntry Leistungsnachweise_ViewEntries[] =
{
   {
      "Alle Leistungsnachweise", "uni_qualifikate", "datum",
      0,
      NULL,
      sizeof(Leistungsnachweise_SelectEntries) / sizeof(SelectEntry),
      (const SelectEntry*)&Leistungsnachweise_SelectEntries,
      sizeof(Leistungsnachweise_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Leistungsnachweise_DescriptionEntries
   }
};


const ViewTable Leistungsnachweise_ViewTable =
{
   {"stud_id", "qal_typ", "datum", "titel", NULL},
   "uni_qualifikate",
   "Pixmaps/Leistungsnachweise.xpm",
   sizeof(Leistungsnachweise_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Leistungsnachweise_ViewEntries
};




// ##########################################################################
// #### Prfungstypen                                                    ####
// ##########################################################################

const DescriptionEntry Pruefungstypen_DescriptionEntries[] =
{
   {"prf_typ", "Typ",          "Prfungs-Typ"},
   {"prf_txt", "Beschreibung", "Beschreibung"},
   {"typ_pruefung", "Prfungstyp", "Tupel der Prfungstypen-Tabelle"}
};

const ViewEntry Pruefungstypen_ViewEntries[] =
{
   {
      "Alle Pruefungstypen", "typ_pruefung", "prf_typ",
      0, NULL,
      0, NULL,
      sizeof(Pruefungstypen_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Pruefungstypen_DescriptionEntries
   }
};


const ViewTable Pruefungstypen_ViewTable =
{
   {"prf_typ", NULL, NULL, NULL, NULL},
   "typ_pruefung",
   "Pixmaps/Prfungstypen.xpm",
   sizeof(Pruefungstypen_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Pruefungstypen_ViewEntries
};




// ##########################################################################
// #### Prfungsstatus                                                   ####
// ##########################################################################

const DescriptionEntry Pruefungsstatus_DescriptionEntries[] =
{
   {"status_typ",    "Status",         "Prfungsstatus-Typ"},
   {"status_txt",    "Beschreibung",   "Beschreibung"},
   {"status_gewertet_bestanden",       "Bestanden?",       "Prfung wird als bestanden gewertet"},
   {"status_gewertet_nichtbestanden",  "Nicht bestanden?", "Prfung wird als nicht bestanden gewertet"},
   {"typ_prfstatus", "Prfungsstatus", "Tupel der Prfungsstatus-Tabelle"}
};

const ViewEntry Pruefungsstatus_ViewEntries[] =
{
   {
     "Alle Pruefungsstatus", "typ_prfstatus", "status_typ",
      0, NULL,
      0, NULL,
      sizeof(Pruefungsstatus_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Pruefungsstatus_DescriptionEntries
   }
};


const ViewTable Pruefungsstatus_ViewTable =
{
   {"status_typ", NULL, NULL, NULL,NULL},
   "typ_prfstatus",
   "Pixmaps/Prfungsstatus.xpm",
   sizeof(Pruefungsstatus_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Pruefungsstatus_ViewEntries
};




// ##########################################################################
// #### Prfungen                                                        ####
// ##########################################################################

const DescriptionEntry Pruefungen_DescriptionEntries[] =
{
   {"stud_id",        "MatrNr",     "Matrikelnummer"},
   {"typ_id",         "Typ",        "Typ"},
   {"gew_pruefer_id", "Gew.Pr.",    "Gewnschter Prfer"},
   {"pruefer_id",     "Prfer",     "Prfer"},
   {"beisitz_id",     "Beisitzer",  "Beisitzer"},
   {"anmelde_datum",  "Anmeldung",  "Datum der Anmeldung"},
   {"thema",          "Thema",      "Thema"},
   {"datum",          "Datum",      "Datum"},
   {"versuch",        "Versuch",    "Versuch"},
   {"zaehler",        "Zhler",     "Zhler"},
   {"status_id",      "Status",     "Status"},
   {"note",           "Note",       "Note"},
   {"bemerkung",      "Bemerkung",  "Bemerkung"},
   {"uni_pruefungen", "Prfung",    "Tupel der Prfungen-Tabelle"}
};

const SelectEntry Pruefungen_SelectEntries[] =
{
   {"typ_id",         "prf_typ",    "prf_txt",       true,  &Pruefungstypen_ViewTable},
   {"status_id",      "status_typ", "status_txt",    true,  &Pruefungsstatus_ViewTable},
   {"pruefer_id",     "pers_id",    "vorname, name, pers_id", false, &Pruefer_ViewTable},
   {"beisitz_id",     "pers_id",    "vorname, name, pers_id", false, &Pruefer_ViewTable},
   {"gew_pruefer_id", "pers_id",    "vorname, name, pers_id", false, &Pruefer_ViewTable},
   {"stud_id", "stud_id", "vorname, name, stud_id",  false, &Studenten_ViewTable}
};

const ViewEntry Pruefungen_ViewEntries[] =
{
   {
      "Alle Prfungen", "uni_pruefungen", "datum",
      0, NULL,
      sizeof(Pruefungen_SelectEntries) / sizeof(SelectEntry),
      (SelectEntry*) Pruefungen_SelectEntries,
      sizeof(Pruefungen_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Pruefungen_DescriptionEntries
   },
   {
      "Bestandene Prfungen", "uni_pruefungen_best", "datum",
      0, NULL,
      sizeof(Pruefungen_SelectEntries) / sizeof(SelectEntry),
      (SelectEntry*) Pruefungen_SelectEntries,
      sizeof(Pruefungen_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Pruefungen_DescriptionEntries
   },
   {
      "Nicht bestandene Prfungen", "uni_pruefungen_nbest", "datum",
      0, NULL,
      sizeof(Pruefungen_SelectEntries) / sizeof(SelectEntry),
      (SelectEntry*) Pruefungen_SelectEntries,
      sizeof(Pruefungen_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Pruefungen_DescriptionEntries
   },
   {
      "Nicht gewertete Prfungen", "uni_pruefungen_ngew", "datum",
      0, NULL,
      sizeof(Pruefungen_SelectEntries) / sizeof(SelectEntry),
      (SelectEntry*) Pruefungen_SelectEntries,
      sizeof(Pruefungen_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Pruefungen_DescriptionEntries
   },
   {
      "Vordiplom-Prfungen", "uni_pruefungen_vd", "datum",
      0, NULL,
      sizeof(Pruefungen_SelectEntries) / sizeof(SelectEntry),
      (SelectEntry*) Pruefungen_SelectEntries,
      sizeof(Pruefungen_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Pruefungen_DescriptionEntries
   },
   {
      "Hauptdiplom-Prfungen", "uni_pruefungen_hd", "datum",
      0, NULL,
      sizeof(Pruefungen_SelectEntries) / sizeof(SelectEntry),
      (SelectEntry*) Pruefungen_SelectEntries,
      sizeof(Pruefungen_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Pruefungen_DescriptionEntries
   }
};


const ViewTable Pruefungen_ViewTable =
{
   {"stud_id", "typ_id", "versuch", "zaehler", NULL},
   "uni_pruefungen",
   "Pixmaps/Prfungen.xpm",
   sizeof(Pruefungen_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Pruefungen_ViewEntries
};




// ##########################################################################
// #### Diplomarbeiten                                                   ####
// ##########################################################################

const DescriptionEntry Diplomarbeiten_DescriptionEntries[] =
{
   {"stud_id",         "MatrNr",       "Matrikelnummer"},
   {"typ_id",          "Typ",          "Typ"},
   {"gew_pruefer_id",  "Gew.Pr.",      "Gewnschter Prfer"},
   {"datum",           "Datum",        "Datum"},
   {"versuch",         "Versuch",      "Versuch"},
   {"zaehler",         "Zhler",       "Zhler"},
   {"thema",           "Thema",        "Thema"},
   {"anmelde_datum",   "Anmeldung",    "Datum der Anmeldung"},
   {"abgabe_datum",    "Abgabe",       "Datum der Abgabe"},
   {"abgabe_limit",    "Abgabe-Limit", "Abgabe-Limit"},
   {"ausgabe_datum",   "Ausgabe",      "Datum der Ausgabe"},
   {"pruefer1_id",     "1.Prfer",     "Erster Prfer"},
   {"pruefer2_id",     "2.Prfer",     "Zweiter Prfer"},
   {"status_id",       "Status",       "Status"},
   {"note",            "Note",         "Note"},
   {"bemerkung",       "Bemerkung",    "Bemerkung"},
   {"uni_diplarbeit",  "Diplomarbeit", "Tupel der Diplomarbeiten-Tabelle"}
};

const SelectEntry Diplomarbeiten_SelectEntries[] =
{
   {"gew_pruefer_id", "pers_id",    "vorname, name, pers_id", false, &Pruefer_ViewTable},
   {"pruefer1_id",    "pers_id",    "vorname, name, pers_id", false, &Pruefer_ViewTable},
   {"pruefer2_id",    "pers_id",    "vorname, name, pers_id", false, &Pruefer_ViewTable},
   {"status_id",      "status_typ", "status_txt",    true,  &Pruefungsstatus_ViewTable},
   {"stud_id", "stud_id", "vorname, name, stud_id",  false, &Studenten_ViewTable}
};


const ViewEntry Diplomarbeiten_ViewEntries[] =
{
   {
      "Alle Diplomarbeiten", "uni_diplarbeit", "anmelde_datum",
      0, NULL,
      sizeof(Diplomarbeiten_SelectEntries) / sizeof(SelectEntry),
      (const SelectEntry*)&Diplomarbeiten_SelectEntries,
      sizeof(Diplomarbeiten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Diplomarbeiten_DescriptionEntries
   },
   {
      "Bestandene Diplomarbeit", "uni_diplarbeit_best", "anmelde_datum",
      0, NULL,
      sizeof(Diplomarbeiten_SelectEntries) / sizeof(SelectEntry),
      (SelectEntry*) Diplomarbeiten_SelectEntries,
      sizeof(Diplomarbeiten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Diplomarbeiten_DescriptionEntries
   },
   {
      "Nicht bestandene Diplomarbeiten", "uni_diplarbeit_nbest", "anmelde_datum",
      0, NULL,
      sizeof(Diplomarbeiten_SelectEntries) / sizeof(SelectEntry),
      (SelectEntry*) Diplomarbeiten_SelectEntries,
      sizeof(Diplomarbeiten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Diplomarbeiten_DescriptionEntries
   },
   {
      "Nicht gewertete Diplomarbeiten", "uni_diplarbeit_ngew", "anmelde_datum",
      0, NULL,
      sizeof(Diplomarbeiten_SelectEntries) / sizeof(SelectEntry),
      (SelectEntry*) Diplomarbeiten_SelectEntries,
      sizeof(Diplomarbeiten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Diplomarbeiten_DescriptionEntries
   }
};


const ViewTable Diplomarbeiten_ViewTable =
{
   {"stud_id", "versuch", "zaehler", NULL, NULL},
   "uni_diplarbeit",
   "Pixmaps/Diplomarbeiten.xpm",
   sizeof(Diplomarbeiten_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Diplomarbeiten_ViewEntries
};



// ##########################################################################
// #### Prfer                                                           ####
// ##########################################################################

const DescriptionEntry Pruefer_DescriptionEntries[] =
{
   {"pers_id", "PersNr",      "Personalnummer"},
   {"name",    "Name",        "Nachname"},
   {"vorname", "Vorname",     "Vorname"},
   {"m_w",     "M/W",         "Mnnlich/Weiblich"},
   {"titel",   "Titel",       "Titel"},
   {"rang",    "Rang",        "Rang"},
   {"einstellung_datum",      "Einstellung",   "Datum der Einstellung"},
   {"pensionierung_datum",    "Pensionierung", "Datum der Pensionierung"},
   {"pers_pruefer", "Prfer", "Tupel der Prfer-Tabelle"}
};

const JoinEntry Pruefer_JoinEntries[] =
{
   {"pers_id", "pers_id",     "Leistungsnachweise", &Leistungsnachweise_ViewTable},
   {"pers_id", "pruefer_id",  "Prfer",             &Pruefungen_ViewTable},
   {"pers_id", "beisitz_id",  "Beisitzer",          &Pruefungen_ViewTable},
   {"pers_id", "pruefer1_id", "1. Prfer DA",       &Diplomarbeiten_ViewTable},
   {"pers_id", "pruefer2_id", "2. Prfer DA",       &Diplomarbeiten_ViewTable},
   {"pers_id", "id",          "Adressen",           &Adressen_ViewTable}
};

const ViewEntry Pruefer_ViewEntries[] =
{
   {
      "Alle Prfer", "pers_pruefer", "name, vorname, titel",
      sizeof(Pruefer_JoinEntries) / sizeof(JoinEntry),
      (const JoinEntry*)&Pruefer_JoinEntries,
      0, NULL,
      sizeof(Pruefer_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Pruefer_DescriptionEntries
   },
   {
      "Vorhandene Prfer", "pers_pruefer_np", "name, vorname, titel",
      sizeof(Pruefer_JoinEntries) / sizeof(JoinEntry),
      (const JoinEntry*)&Pruefer_JoinEntries,
      0, NULL,
      sizeof(Pruefer_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Pruefer_DescriptionEntries
   },
   {
      "Pensionierte Prfer", "pers_pruefer_pe", "name, vorname, titel",
      sizeof(Pruefer_JoinEntries) / sizeof(JoinEntry),
      (const JoinEntry*)&Pruefer_JoinEntries,
      0, NULL,
      sizeof(Pruefer_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Pruefer_DescriptionEntries
   }
};


const ViewTable Pruefer_ViewTable =
{
   {"pers_id", NULL, NULL, NULL, NULL},
   "pers_pruefer",
   "Pixmaps/Prfer.xpm",
   sizeof(Pruefer_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Pruefer_ViewEntries
};



// ##########################################################################
// #### Studenten                                                        ####
// ##########################################################################

const DescriptionEntry Studenten_DescriptionEntries[] =
{
   {"stud_id",        "MatrNr",          "Matrikelnummer"},
   {"name",           "Name",            "Nachname"},
   {"vorname",        "Vorname",         "Vorname"},
   {"m_w",            "M/W",             "Mnnlich/Weiblich"},
   {"geb_datum",      "GebDatum",        "Geburtsdatum"},
   {"geb_ort",        "GebOrt",          "Geburtsort"},
   {"semester",       "Semester",        "Semester"},
   {"immat_datum",    "Immatrikulation", "Datum der Immatrikulation"},
   {"exmat_datum",    "Exmatrikulation", "Datum der Exmatrikulation"},
   {"nebenfach",      "Nebenfach",       "Nebenfach"},
   {"pers_studenten", "Student",         "Tupel der Studenten-Tabelle"}
};

const JoinEntry Studenten_JoinEntries[] =
{
   {"stud_id", "stud_id", "Leistungsnachweise", &Leistungsnachweise_ViewTable},
   {"stud_id", "stud_id", "Prfungen",          &Pruefungen_ViewTable},
   {"stud_id", "stud_id", "Diplomarbeit",       &Diplomarbeiten_ViewTable},
   {"stud_id", "id",      "Adressen",           &Adressen_ViewTable},
   {"stud_id", "stud_id", "Studium",            &Studium_ViewTable}
};


const ViewEntry Studenten_ViewEntries[] =
{
   {
      "Alle Studenten",
      "pers_studenten", "name, vorname, stud_id",
      sizeof(Studenten_JoinEntries) / sizeof(JoinEntry),
      (const JoinEntry*)&Studenten_JoinEntries,
      0, NULL,
      sizeof(Studenten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Studenten_DescriptionEntries
   },
   {
      "Grundstudiums-Studenten",
      "pers_studenten_gs", "name, vorname, stud_id",
      sizeof(Studenten_JoinEntries) / sizeof(JoinEntry),
      (const JoinEntry*)&Studenten_JoinEntries,
      0, NULL,
      sizeof(Studenten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Studenten_DescriptionEntries
   },
   {
      "Hauptstudiums-Studenten",
      "pers_studenten_hs", "name, vorname, stud_id",
      sizeof(Studenten_JoinEntries) / sizeof(JoinEntry),
      (const JoinEntry*)&Studenten_JoinEntries,
      0, NULL,
      sizeof(Studenten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Studenten_DescriptionEntries
   },
   {
      "Diplomanden",
      "pers_studenten_dipl", "name, vorname, stud_id",
      sizeof(Studenten_JoinEntries) / sizeof(JoinEntry),
      (const JoinEntry*)&Studenten_JoinEntries,
      0, NULL,
      sizeof(Studenten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Studenten_DescriptionEntries
   },
   {
      "Geprfte Studenten",
      "pers_studenten_gepr", "name, vorname, stud_id",
      sizeof(Studenten_JoinEntries) / sizeof(JoinEntry),
      (const JoinEntry*)&Studenten_JoinEntries,
      0, NULL,
      sizeof(Studenten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Studenten_DescriptionEntries
   },
   {
      "Ungeprfte Studenten",
      "pers_studenten_ungepr", "name, vorname, stud_id",
      sizeof(Studenten_JoinEntries) / sizeof(JoinEntry),
      (const JoinEntry*)&Studenten_JoinEntries,
      0, NULL,
      sizeof(Studenten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Studenten_DescriptionEntries
   },
   {
      "Langzeit-Studenten",
      "pers_studenten_lz", "name, vorname, stud_id",
      sizeof(Studenten_JoinEntries) / sizeof(JoinEntry),
      (const JoinEntry*)&Studenten_JoinEntries,
      0, NULL,
      sizeof(Studenten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Studenten_DescriptionEntries
   },
   {
      "Immatrikulierte Studenten",
      "pers_studenten_im", "name, vorname, stud_id",
      sizeof(Studenten_JoinEntries) / sizeof(JoinEntry),
      (const JoinEntry*)&Studenten_JoinEntries,
      0, NULL,
      sizeof(Studenten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Studenten_DescriptionEntries
   },
   {
      "Exmatrikulierte Studenten",
      "pers_studenten_ex", "name, vorname, stud_id",
      sizeof(Studenten_JoinEntries) / sizeof(JoinEntry),
      (const JoinEntry*)&Studenten_JoinEntries,
      0, NULL,
      sizeof(Studenten_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Studenten_DescriptionEntries
   }
};


const ViewTable Studenten_ViewTable =
{
   {"stud_id",NULL,NULL,NULL,NULL},
   "pers_studenten",
   "Pixmaps/Studenten.xpm",
   sizeof(Studenten_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Studenten_ViewEntries
};



// ##########################################################################
// #### Statistiken                                                      ####
// ##########################################################################


const DescriptionEntry Statistiken_DescriptionEntries[] =
{
   {"pers_id",  "PersNr",        "Personalnummer"},
   {"stud_id",  "MatrNr",        "Matrikelnummer"},
   {"name",     "Name",          "Nachname"},
   {"semester", "Semester",      "Semester"},
   {"vorname",  "Vorname",       "Vorname"},
   {"gesamt",   "Gesamt",        "Gesamt"},
   {"nb",       "N.B.",          "Nicht bestanden"},
   {"b",        "Best.",         "Bestanden"},
   {"ng",       "N.G.",          "Nicht gewertet"},
   {"avgnote",  "DNote",         "Durchschnittsnote"},
   {"dquote",   "Df.-Quote",     "Quote"},
   {"qal_typ",  "Qualifikattyp", "Qualifikattyp"},
   {"qanzahl",  "Leistnw.",      "Anzahl der Leistungsnachweise"},
   {"qps",      "Lnw./Sem.",     "Leistungsnachweise pro Semester"},
   {"heute",       "Heute",              "Heute"},
   {"studenten",   "Anzahl Studenten",   "Anzahl Studenten"},
   {"pruefer",     "Anzahl Prfer",      "Anzahl Prfer"},
   {"jahr",        "Jahr",               "Jahr"},
   {"pruefer",     "Prfer",             "Prfer"},
   {"prueferw",    "Prf/W",              "Prfer, weiblich"},
   {"studenten",   "Studenten",          "Studenten"},
   {"studentenw",  "Std/W",              "Studenten, weiblich"},
   {"pfq",         "Prf/FQ",             "Prfer, Frauenquote"},
   {"sfq",         "Std/FQ",             "Studenten, Frauenquote"},
   {"studienzeit", "Studienzeit",        "Durchschnittliche Studienzeit"},
   {"leistnw",     "Leistungsnachweise", "Leistungsnachweise"},
   {"diplome",     "Diplome",            "Diplome"},
   {"vordiplome",  "Vordiplome",         "Voriplome"}
};


const ViewEntry Statistiken_ViewEntries[] =
{
   {
      "Anzahl", "stat_anzahl", "heute",
      0, NULL,
      0, NULL,
      sizeof(Statistiken_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Statistiken_DescriptionEntries
   },
   {
      "Jahresstatistik", "stat_jahre", "jahr",
      0, NULL,
      0, NULL,
      sizeof(Statistiken_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Statistiken_DescriptionEntries
   },
   {
      "Prfer/Prfungen", "stat_pruefer_prf", "name, vorname, pers_id",
      0, NULL,
      0, NULL,
      sizeof(Statistiken_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Statistiken_DescriptionEntries
   },
   {
      "Prfer/Leistnw.", "stat_pruefer_qal", "name, vorname, pers_id, qal_typ",
      0, NULL,
      0, NULL,
      sizeof(Statistiken_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Statistiken_DescriptionEntries
   },
   {
      "Studenten/Prfungen", "stat_stud_prf", "name, vorname, stud_id",
      0, NULL,
      0, NULL,
      sizeof(Statistiken_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Statistiken_DescriptionEntries
   },
   {
      "Studenten/Leistnw.", "stat_stud_qal", "name, vorname, stud_id",
      0, NULL,
      0, NULL,
      sizeof(Statistiken_DescriptionEntries) / sizeof(DescriptionEntry),
      (const DescriptionEntry*)&Statistiken_DescriptionEntries
   }
};

const ViewTable Statistiken_ViewTable =
{
   {NULL, NULL, NULL, NULL, NULL},
   "(null)",
   "Pixmaps/Statistik.xpm",
   sizeof(Statistiken_ViewEntries) / sizeof(ViewEntry),
   (const ViewEntry*)&Statistiken_ViewEntries
};



// ##########################################################################
// #### Liste der optimierbaren Tabellen                                 ####
// ##########################################################################


const char* PADB_OptimizeTableEntries[] =
{
   "uni_pruefungen",
   "uni_diplarbeit",
   "uni_studium",
   "uni_qualifikate",
   "pers_studenten",
   "pers_pruefer",
   "pers_adressen",
   "typ_qualifikate",
   "typ_prfstatus",
   "typ_pruefung",
   "typ_adressen",
   "typ_studium"
};

const struct OptimizeTable PADB_OptimizeTable =
{
   sizeof(PADB_OptimizeTableEntries) / sizeof(const char*),
   (const char**)&PADB_OptimizeTableEntries
};



// ##########################################################################
// #### Umsetzung der internen Attributnamen in Titel und Hilfe-Text     ####
// ##########################################################################


// ###### Titel aus Description holen #######################################
const QString ViewEntry::toTitle(const char* name) const
{
   for(cardinal i = 0;i < Descriptions;i++) {
      if(!(strcmp(Description[i].Field,name))) {
         return(Description[i].Title);
      }
   }
   return(name);
}


// ###### Hilfe aus Description holen #######################################
const QString ViewEntry::toHelp(const char* name) const
{
   for(cardinal i = 0;i < Descriptions;i++) {
      if(!(strcmp(Description[i].Field,name))) {
         return(Description[i].Help);
      }
   }
   return(name);
}
