// ##########################################################################
// ####                                                                  ####
// ####                         Prfungsamt-Client                       ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Datenbank-Exception                                              ####
// ####                                                                  ####
// #### Version 1.00  --  12. Juli 2000                                  ####
// ####                                                                  ####
// #### Copyright (C) 2000  Thomas Dreibholz                             ####
// ####                     Universitt Bonn                             ####
// ####                     EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################


#ifndef SQL_EXCEPTION_H
#define SQL_EXCEPTION_H


#include "system.h"


/**
  * SQLException ist ein Exception, die bei einem SQL-Fehler aufgeworfen wird.
  *
  * @short   SQL Exception
  * @author  Thomas Dreibholz (Dreibholz@bigfoot.com)
  * @version 1.0
  */
class SQLException
{
   // ====== Constructor/Destructor =========================================
   public:
   /**
     * Constructor.
     *
     * @param title Exception-Titel.
     */
   SQLException(const char* title = NULL);

   /**
     * Destructor.
     */
   virtual ~SQLException();


   // ====== Exception-Titel zurckgeben ====================================
   /**
     * Exception-Titel zurckgeben.
     *
     * @return Titel
     */
   virtual const char* toString() const;


   /**
     * Ausgabe-Operator.
     */
   friend ostream& operator<<(ostream& os, const SQLException e);


   // ====== Private Daten ==================================================
   private:
   static const card32 MaxTitleLength = 256;

   char Title[MaxTitleLength];
};


#endif
