// ##########################################################################
// ####                                                                  ####
// ####                         Prfungsamt-Client                       ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### System-abhngige Konfiguration                                   ####
// ####                                                                  ####
// #### Version 1.00  --  12. Juli 2000                                  ####
// ####                                                                  ####
// #### Copyright (C) 2000  Thomas Dreibholz                             ####
// ####                     Universitt Bonn                             ####
// ####                     EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################

 
#ifndef SYSTEM_H
#define SYSTEM_H


// Some important definitions for usage of reentrant versions.
#ifndef _REENTRANT
#define _REENTRANT
#endif
#define _THREAD_SAFE
#define _GNU_SOURCE
#define USE_PTHREADS


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <iostream.h>
#include <string.h>
#include <math.h>
#include <endian.h>


#ifndef max
#define max(a, b) ((a) < (b) ? (b) : (a))
#endif
#ifndef min
#define min(a, b) ((a) > (b) ? (b) : (a))
#endif


// ###### CPU defintions ####################################################
// Set correct number of CPU bits (32 or 64) here!
#if (defined __i386__) || (defined __i486__) || (defined __pentium__) || (defined __pentiumpro__)
#define CPU_BITS 32
#else
#error "CPU_BITS is not set correctly! Check system.h!"
#endif

#define CPU_BYTEORDER __BYTE_ORDER
#if ((CPU_BYTEORDER != BIG_ENDIAN) && (CPU_BYTEORDER != LITTLE_ENDIAN))
#error "CPU_BYTEORDER is not set correctly! Check system.h!"
#endif


// ###### Type definitions ##################################################
/**
  * Datatype for storing a signed char.
  */
typedef signed char sbyte;

/**
  * Datatype for storing an unsigned char.
  */
typedef unsigned char ubyte;

/**
  * Datatype for storing an 8-bit integer.
  */
typedef signed char int8;

/**
  * Datatype for storing a 8-bit cardinal.
  */
typedef unsigned char card8;

/**
  * Datatype for storing a 16-bit integer.
  */
typedef signed short int16;

/**
  * Datatype for storing a 16-bit cardinal.
  */
typedef unsigned short card16;

/**
  * Datatype for storing a 32-bit intger.
  */
typedef signed int int32;

/**
  * Datatype for storing a default-sized integer (32 bits minimum).
  */
typedef signed int integer;

/**
  * Datatype for storing a 32-bit cardinal.
  */
typedef unsigned int card32;

/**
  * Datatype for storing an 64-bit integer.
  */
typedef signed long long int64;

/**
  * Datatype for storing a 64-bit cardinal.
  */
typedef unsigned long long card64;

/**
  * Datatype for storing a default-sized cardinal (32 bits minimum).
  */
typedef unsigned int cardinal;


#endif
  