// ##########################################################################
// ####                                                                  ####
// ####                         Prfungsamt-Client                       ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Text-Monitor                                                     ####
// ####                                                                  ####
// #### Version 1.00  --  12. Juli 2000                                  ####
// ####                                                                  ####
// #### Copyright (C) 2000  Thomas Dreibholz                             ####
// ####                     Universitt Bonn                             ####
// ####                     EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################


#include "system.h"
#include "textmonitor.h"


#include <qapp.h>
#if QT_VERSION < 210
#error QT Version 2.1 or better required!!!
#endif
#include <qlayout.h>
#include <qpushbutton.h>
#include <qmultilineedit.h>


#include "textmonitor.moc"


// ###### Constructor #######################################################
TextMonitor::TextMonitor(QWidget*    parent,
                         const char* name)
{
   QGridLayout* topLayout = new QGridLayout(this,2,2,5);
   CHECK_PTR(topLayout);


   // ====== Buttons ========================================================
   QPushButton* closeButton = new QPushButton("Schlieen",this);
   CHECK_PTR(closeButton);
   topLayout->addWidget(closeButton,1,0);

   QPushButton* clearButton = new QPushButton("Ausgabe lschen",this);
   CHECK_PTR(clearButton);
   topLayout->addWidget(clearButton,1,1);


   // ====== Ausgabe-Textfeld ===============================================
   Output = new QMultiLineEdit(this);
   CHECK_PTR(Output);
   Output->setReadOnly(true);
   topLayout->addMultiCellWidget(Output,0,0,0,1);


   // ====== Qt-Signale verbinden ===========================================
   QObject::connect(closeButton,SIGNAL(clicked()),this,SLOT(hide()));
   QObject::connect(clearButton,SIGNAL(clicked()),Output,SLOT(clear()));
   setMinimumSize(600,200);
}


// ###### Zeile im TextMonitor ausgeben #####################################
void TextMonitor::write(const char* string)
{
   Output->append(string);
   Output->setCursorPosition(Output->numLines(),0);
}
